<template>
  <div
    id="app"
    class="small-container"
  >
    <h1>Groups</h1>

    <group-form @add:group="addGroup" />
    <group-table
      :groups="groups"
      @delete:group="deleteGroup"
      @edit:group="editGroup"
    />

  </div>
</template>

<script>
import GroupTable from '@/components/GroupTable.vue'
import GroupForm from '@/components/GroupForm.vue'
import PhonenumberTable from '@/components/PhonenumberTable.vue'
import MultiSelectForm from '@/components/MultiSelectForm.vue'






export default {
  name: "app",
  components: {
   GroupTable,
   GroupForm,
   PhonenumberTable,
   MultiSelectForm,
   
  },
  data() {
    return {
      groups: [],
      phonenumber:[],
      
      
    }
    
  },
  

  mounted() {
    this.getGroups()
  },

  methods: {
    // WHEN ALL GROUPS API IS READY, I WILL UNCOMMENT THIS METHOD AND FETCH THE API

    async getGroups() {
      try {
        const response = await fetch('#')
        const data = await response.json()
        this.groups = data
      } catch (error) {
        console.error(error)
      }
    },

    async addGroup(group) {
      try {
        const response = await fetch('https://jsonplaceholder.typicode.com/users', {
          method: 'POST',
          body: JSON.stringify(group),
          headers: { "Content-type": "application/json; charset=UTF-8" }
        })
        const data = await response.json()
        this.groups = [...this.groups, data]
      } catch (error) {
        console.error(error)
      }
    },

    async editGroup(id, updatedGroup) {
      try {
        const response = await fetch(`https://jsonplaceholder.typicode.com/users/${id}`, {
          method: 'PUT',
          body: JSON.stringify(updatedGroup),
          headers: { "Content-type": "application/json; charset=UTF-8" }
        })
        const data = await response.json()
        this.groups = this.groups.map(group => group.id === id ? data : group)
      } catch (error) {
        console.error(error)
      }
    },

    async deleteGroup(id) {
      try {
        await fetch(`https://jsonplaceholder.typicode.com/users/${id}`, {
          method: 'DELETE',
        })
        this.groups = this.groups.filter(group => group.id !== id)
      } catch (error) {
        console.error(error)
      }
    },
    addTag(newTag) {
            const tag = { name: newTag, code: newTag.substring(0, 2) + Math.floor((Math.random() * 10000000)) }
            this.options.push(tag)
            this.value.push(tag)
        }
    }
  }

</script>

<style>

button {
  background: #009435;
  border: 1px solid #009435;
}

button:hover,
button:active,
button:focus {
  background: #32a95d;
  border: 1px solid #32a95d;
}

.small-container {
  max-width: 680px;
}
</style>
